/***************************************************************************
**    $Header:   D:/ECB2S/SRC/LOG/BA.CPP   1.2.1.5   17 Apr 1997 15:41:32   ZJRD  $
**
**    $Log:   D:/ECB2S/SRC/LOG/BA.CPP  $
** 
**    Rev 1.2.1.5   17 Apr 1997 15:41:32   ZJRD
** No change.
** 
**    Rev 1.2.1.4   16 Apr 1997 10:15:32   ZJRD
** No change.
** 
**    Rev 1.2.1.3   10 Apr 1997 15:27:20   ZJRD
** 2.09F
** 
**    Rev 1.2.1.1   03 Apr 1997 15:09:16   ZJRD
** No change.
** 
**    Rev 1.2.1.0   28 Mar 1997 10:14:14   ZJRD
** easy pack sld 2.09d
** 
**    Rev 1.1   19 Mar 1997 11:25:34   ZJRD
** Easy Pack SLD 2.09c
**
**    $Header:   D:/ECB2S/SRC/LOG/BA.CPP   1.2.1.5   17 Apr 1997 15:41:32   ZJRD  $
**
**    $Log$
** 
**    Rev 1.4.1.0.1.2   09 Dec 1996 10:15:16   ZJRD
** EasyPack/SLD Version 2.0P
** 
**    Rev 1.4.1.0.1.0   11 Nov 1996 12:58:32   ZJRD
** EasyPack/SLD Version 2.01
** 
**    Rev 1.4.1.4   09 Sep 1996 13:15:58   ZJRD
** No change.
** 
**    Rev 1.4.1.3   05 Sep 1996 11:27:32   ZJRD
** No change.
** 
**    Rev 1.4.1.2   02 Sep 1996 09:54:38   ZJRD
** No change.
** 
**    Rev 1.4.1.1   28 Aug 1996 15:48:50   ZJRD
** EasyPack/SLD Version 1.9b
** 
**    Rev 1.4.1.0   12 Aug 1996 10:53:12   ZJRD
** EasyPack/SLD Version 1.98
** 
**    Rev 1.1   29 May 1996 09:36:32   ZJRD
** EasyPack/SLD Version 1.95
** 
****************************************************************************/

/////////////////////////////////////////////////////////////////////////////
// ba.cpp
//
// Michael Long
//                                                                           
// 5/13/96
//
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"

#include "toolopt.h"
#include "ba.h"

/////////////////////////////////////////////////////////////////////////////
// diagnostic
#ifdef _DEBUG
void BATool::Dump(CDumpContext &dc) const
{         
    CToolOption::Dump(dc);
    dc << "m_fX = " << m_fX << "\n";
    dc << "m_fE = " << m_fE << "\n";
    dc << "m_fS = " << m_fS << "\n";
    dc << "m_strMore = " << m_strMore << "\n";
    dc << "m_strPath = " << m_strPath << "\n"; 
    dc << "m_incPath = " << m_incPath << "\n";
}
#endif

/////////////////////////////////////////////////////////////////////////////
// operations
void BATool::SetDefault(void)
{
    m_fX = TRUE;
    m_fE = FALSE;
    m_fS= TRUE;
    m_strMore = " F  ";
    m_strPath = "c:\\icc8051\\exe";
    m_incPath = "c:\\icc8051\\inc";
}

BOOL BATool::LoadOption(FILE * fp)
{
    ASSERT(fp);
    
    const int nCnt = 3;
    
    char bch[nCnt];
    
    if(fread(bch, 1, nCnt, fp) != nCnt)
        return FALSE;
        
    m_fX = bch[0];
    m_fE = bch[1];
    m_fS = bch[2];
    WORD wLen;
    if(fread(&wLen, 2, 1, fp) != 1)
        return FALSE;
    if(wLen > (WORD)32000)
        return FALSE;
        
    if(fread(m_strMore.GetBuffer(wLen), 1, wLen, fp) != wLen)
        return FALSE;

    m_strMore.ReleaseBuffer(wLen);  
    
    if(fread(&wLen, 2, 1, fp) != 1)
        return FALSE;
    if(wLen > (WORD)32000)
        return FALSE;
        
    if(fread(m_strPath.GetBuffer(wLen), 1, wLen, fp) != wLen)
        return FALSE;

    m_strPath.ReleaseBuffer(wLen);  
    
     if(fread(&wLen, 2, 1, fp) != 1)
        return FALSE;
    if(wLen > (WORD)32000)
        return FALSE;
        
    if(fread(m_incPath.GetBuffer(wLen), 1, wLen, fp) != wLen)
        return FALSE;

    m_incPath.ReleaseBuffer(wLen);  

    return TRUE;
}                 

BOOL BATool::SaveOption(FILE * fp)
{
    ASSERT(fp);
    
    const int nCnt = 3;

    char bch[nCnt];
    
    bch[0] = char(m_fX);
    bch[1] = char(m_fE);
    bch[2] = char(m_fS);
    
  if(fwrite(bch, 1, nCnt, fp) != nCnt)
        return FALSE;
             
    WORD wLen = WORD(m_strMore.GetLength());           
    if(fwrite(&wLen, 2, 1, fp) != 1)
        return FALSE;
        
    if(fwrite(m_strMore.GetBuffer(wLen), 1, wLen, fp) != wLen)
        return FALSE;

    m_strMore.ReleaseBuffer(wLen);  
    
    wLen = WORD(m_strPath.GetLength());           
    if(fwrite(&wLen, 2, 1, fp) != 1)
        return FALSE;
        
    if(fwrite(m_strPath.GetBuffer(wLen), 1, wLen, fp) != wLen)
        return FALSE;

    m_strPath.ReleaseBuffer(wLen);  
    
    wLen = WORD(m_incPath.GetLength());           
    if(fwrite(&wLen, 2, 1, fp) != 1)
        return FALSE;
        
    if(fwrite(m_incPath.GetBuffer(wLen), 1, wLen, fp) != wLen)
        return FALSE;

    m_incPath.ReleaseBuffer(wLen);  
        return TRUE;
}

CString BATool::GetOption(void) const
{
    CString str = " ";
    
    if(m_fX)
        str += "X ";
        
    if(m_fE)
        str += "E ";
        
    if(m_fS)   
        str += "S ";
        
    str += m_strMore;
    str += " ";
    
    return str;
}

